package com.example.shikan.eldelbar;

import android.content.ContentValues;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.example.shikan.eldelbar.database.EldelbarDB;
import com.example.shikan.eldelbar.database.entidades.Gasto;
import com.facebook.stetho.Stetho;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;


public class ActualPresupuesto extends AppCompatActivity{

    private TextView tv_presupuesto;
    private TextView tv_gastado;
    private TextView tv_local;
    private EditText et_descripcion;
    private EditText et_precio;
    private Button btn_anyadirGasto;
    private TextView tv_descripcionSalida;
    private Button btn_finSesion;
    private double LlevaGastado;
    private int conseguido;
    private int terminada; //Para averiguar si la sesion sigue activa o no

    //RecyclerView
    private RecyclerView recyclerView;
    private ListaGastosRecyclerViewAdapter adapter;
    private RecyclerView.LayoutManager layoutManager;
    private ArrayList<Gasto> listaGastos;

    //Variables para rellenar la BD
    private String inicio_sesion;
    private String fecha_sesion;
    private String fecha_gasto;
    private String hora_sesion;
    private String hora_gasto;
    private double precio;
    private String descripcion;
    private String fecha_hora_fin;
    private String fecha_hora_inicio;
    private String Id_sesion;
    private String fecha_fin_sesion;
    private String hora_fin_sesion;
    private double total_gastado;
    private int id_gasto;
    private double presupuestoActual;
    private String descripcionSalida;
    private String pasarPresupuesto;
    private String nombreLocal;
    private String localizacion;
    private String direccionLocal;
    private String id_sesion_abierta;


    private EldelbarDB db;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Stetho.initializeWithDefaults(this);
        setContentView(R.layout.activity_actual_presupuesto);

        //Recyclerview
        recyclerView = findViewById(R.id.lista_de_gastos);
        layoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(layoutManager);
        recyclerView.setHasFixedSize(true);
        listaGastos = new ArrayList<>();

        //Conectamos a la BD
        db = new EldelbarDB(getApplicationContext());

        tv_presupuesto = findViewById(R.id.tvPresupuestoActual);
        tv_descripcionSalida = findViewById(R.id.descripcionSalida);
        tv_gastado = findViewById(R.id.TV_gastado);
        tv_local = findViewById(R.id.local);

        presupuestoActual  = getIntent().getDoubleExtra("presupuesto",0.0);
        descripcionSalida = getIntent().getStringExtra("descripcionSalida");
        pasarPresupuesto = Double.valueOf(presupuestoActual).toString();
        nombreLocal = getIntent().getStringExtra("nombreLocal");
        localizacion = getIntent().getStringExtra("localizacionLocal");
        direccionLocal = getIntent().getStringExtra("direccionLocal");
        id_sesion_abierta = getIntent().getStringExtra("id_sesion_abierta");

        et_descripcion = findViewById(R.id.descripcion);
        et_precio = findViewById(R.id.precio);
        btn_anyadirGasto = findViewById(R.id.anyadirGasto);
        btn_finSesion = findViewById(R.id.fin_sesion);
        total_gastado = 0.0;
        terminada = 0;

        //Obtenemos la fecha y hora de la sesion
        fecha_sesion = new SimpleDateFormat("dd/MM/yyyy").format(new Date());
        hora_sesion = new SimpleDateFormat("HH:mm:ss").format(new Date());
        fecha_hora_inicio = fecha_sesion+"_"+hora_sesion;

        Id_sesion = getIntent().getStringExtra("id_sesion");
        Log.d("Sesion","Sesion despues de Intent: "+Id_sesion);

        if(Id_sesion != null) {
            presupuestoActual = getIntent().getDoubleExtra("presupuestoActual_fromLocalizacion",0.0);
            total_gastado = getIntent().getDoubleExtra("total_gastado_fromLocalizacion",0.0);
            descripcionSalida = getIntent().getStringExtra("descripcionSalida_fromLocalizacion");
            localizacion = getIntent().getStringExtra("LocalizacionLocal");
            Log.d("Sesion","Localizacion: "+localizacion);
        }else{
            Id_sesion = presupuestoActual + "_" + fecha_hora_inicio;
            db.AgregarSesion(Id_sesion,presupuestoActual,fecha_hora_inicio,terminada,descripcionSalida);
            Log.d("Sesion","Sesion creada: "+Id_sesion);
        }


        listaGastos = db.obtenerGastos(Id_sesion);
        Log.d("Recycler","listaGastos: "+listaGastos);
        adapter = new ListaGastosRecyclerViewAdapter(listaGastos, getApplicationContext());
        recyclerView.setAdapter(adapter);

        tv_local.setText(nombreLocal);
        pasarPresupuesto = Double.valueOf(presupuestoActual).toString();
        tv_presupuesto.setText(pasarPresupuesto);
        tv_descripcionSalida.setText(descripcionSalida);
        tv_gastado.setText(Double.valueOf(total_gastado).toString());

        //inicializarRecycler();

        // Obtenemos el nombre del local en el que estamos
        tv_local.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent i = new Intent(getApplicationContext(),Localizacion.class);
                i.putExtra("id_sesion",Id_sesion);
                i.putExtra("total_gastado",total_gastado);
                i.putExtra("presupuestoActual",presupuestoActual);
                i.putExtra("descripcionSalida",descripcionSalida);
                startActivity(i);
            }
        });


        btn_anyadirGasto.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

               /* Snackbar.make(view, "Se presionó el FAB", Snackbar.LENGTH_LONG)
                        .setAction("Action", null).show();*/
                //TODO: Presentamos la info fecha+hora, precio, descripcion en la pantalla y luego la guardamos en la bd

                /*
                 * Sesion = {Id_Sesion+total_gastado+conseguido?+fecha_hora_inicio+fecha_hora_fin}
                 * Gastos = {Id_Sesion+Fecha+Hora+Precio+Descripcion}
                 *
                 */

                fecha_gasto = new SimpleDateFormat("dd/MM/yyyy").format(new Date());
                hora_gasto = new SimpleDateFormat("HH:mm").format(new Date());

                /*
                 * TODO:Recogemos los datos de sesion: id_sesion = presupuesto+fecha_hora_inicio; fecha_hora_inicio
                 */

                et_descripcion = findViewById(R.id.descripcion);
                descripcion = et_descripcion.getText().toString();


                //Precio
                et_precio = findViewById(R.id.precio);


                if((et_descripcion.getText().toString()).equals("") || (et_precio.getText().toString()).equals("")|| (tv_local.getText().toString()).equals("")) {

                    Toast msg = Toast.makeText(getApplicationContext(),"Error: Ha de rellenar todos los campos", Toast.LENGTH_SHORT);
                    msg.show();

                }else{
                    precio = Double.parseDouble(et_precio.getText().toString());


                        total_gastado += precio;
                        //meQuedan -= precio;

                        tv_gastado.setText(Double.valueOf(total_gastado).toString());

                        establecerColorTotalGastado();

                        db.AgregarGasto(Id_sesion,fecha_gasto,hora_gasto,precio,descripcion,nombreLocal,direccionLocal,localizacion);

                        et_precio.setText("");
                        et_descripcion.setText("");

                        //Rellenamos la listagastos con los gastos de la tabla
                        //listaGastos = db.obtenerGastos();

                        Log.d("BD","Estamos en Presupuesto Actual");

                    inicializarRecycler();

                }


            }
        });

        //Al finalizar la sesion, terminamos de completar la tabla sesion

        btn_finSesion.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //Hemos de terminar de rellenar la tabla Sesion con los datos que faltan: fecha_Hora_fin, total_gastado, conseguido?
                //Obtenemos fecha_hora_fin
                fecha_fin_sesion = new SimpleDateFormat("dd/MM/yyyy").format(new Date());
                hora_fin_sesion = new SimpleDateFormat("HH:mm:ss").format(new Date());
                fecha_hora_fin = fecha_fin_sesion +" "+hora_fin_sesion;

                //Marcamos la sesion como terminada
                terminada = 1;

                //Añadimos los campos que faltan a la variable sesion
                db.TerminarSesion(Id_sesion,total_gastado,conseguido,fecha_hora_inicio,terminada);

                Intent i = new Intent(getApplicationContext(),GastosFinSesion.class);
                i.putExtra("id_sesion", Id_sesion);
                i.putExtra("descripcion", descripcionSalida);
                i.putExtra("fecha", fecha_sesion);
                i.putExtra("presupuesto", presupuestoActual);
                i.putExtra("total_gastado", total_gastado);
                startActivity(i);
            }
        });


    }//fin onCreate()


    @Override
    public void onSaveInstanceState(Bundle savedInstanceState) {

        //Guardamos presupuesto, total_gastado, Id_sesion, Local, descripcion, precio

        savedInstanceState.putDouble("presupuestoActual", presupuestoActual);
        savedInstanceState.putDouble("total_gastado", total_gastado);
        savedInstanceState.putString("Id_sesion", Id_sesion);
        savedInstanceState.putString("nombreLocal", nombreLocal);
        savedInstanceState.putString("descripcion", descripcion);
        savedInstanceState.putString("descripcionSalida",descripcionSalida);
        savedInstanceState.putDouble("precio", precio);

        // Always call the superclass so it can save the view hierarchy state
        super.onSaveInstanceState(savedInstanceState);
    }

    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState){
        super.onRestoreInstanceState(savedInstanceState);

        presupuestoActual = savedInstanceState.getDouble("presupuestoActual");
        total_gastado = savedInstanceState.getDouble("total_gastado");
        Id_sesion = savedInstanceState.getString("Id_sesion");
        nombreLocal = savedInstanceState.getString("nombreLocal");
        descripcion = savedInstanceState.getString("descripcion");
        descripcionSalida = savedInstanceState.getString("descripcionSalida");
        precio = savedInstanceState.getDouble("precio");

        tv_descripcionSalida.setText(descripcionSalida);
        tv_gastado.setText(Double.valueOf(total_gastado).toString());
        tv_presupuesto.setText(Double.valueOf(presupuestoActual).toString());

        inicializarRecycler();
    }


    //Inicializamos la lista de gastos RecyclerView
    public void inicializarRecycler(){

        Log.d("BD","Estamos en inicializarRecycler");

        listaGastos = db.obtenerGastos(Id_sesion);
        Log.d("Recycler","listaGastos: "+listaGastos);
        adapter = new ListaGastosRecyclerViewAdapter(listaGastos, getApplicationContext());

        adapter.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {

                id_gasto = listaGastos.get(recyclerView.getChildAdapterPosition(v)).getId_gasto();

                AlertDialog.Builder builder = new AlertDialog.Builder(ActualPresupuesto.this);

                // Add the buttons
                builder.setTitle("Borrar Gasto?")
                        .setPositiveButton(R.string.alert_dialog_SI, new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                                // User clicked OK button
                                eliminarGasto();
                            }
                        });

                builder.setNegativeButton(R.string.alert_dialog_NO, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        // User cancelled the dialog
                        Toast msg = Toast.makeText(getApplicationContext(),"Cancelado", Toast.LENGTH_SHORT);
                        msg.show();
                    }
                });

                // Create the AlertDialog
                builder.create();
                builder.show();
            }
        });

        recyclerView.setAdapter(adapter);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
    }

    public void eliminarGasto(){

        ArrayList<Gasto> gastos = db.obtenerGastos(Id_sesion);
        double gastoABorrar = 0;

        for(int i= 0; i< gastos.size(); i++){
            if(gastos.get(i).getId_sesion() == Id_sesion){
                gastoABorrar = gastos.get(i).getPrecio();
            }
        }

        //double gastoABorrar = db.obtenerGastoABorrar(id_gasto);
        total_gastado -= gastoABorrar;
        tv_gastado.setText(Double.valueOf(total_gastado).toString());
        establecerColorTotalGastado();

        db.eliminarGasto(Id_sesion,id_gasto);

        Toast msg = Toast.makeText(getApplicationContext(),"Gasto Eliminado correctamente", Toast.LENGTH_SHORT);
        msg.show();
        inicializarRecycler();
    }

    /*
            MENU
     */

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.layout.menu, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
            case R.id.menu_NuevoPresupuesto:
                nuevoPresupuesto();
                return true;
            case R.id.menu_Historico:
                Historico();
                return true;
            case R.id.menu_Localizar:
                Localizar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void nuevoPresupuesto(){
        Intent presupuesto = new Intent(getApplicationContext(),NuevoPresupuesto.class);
        startActivity(presupuesto);
    }

    public void Historico(){
        Intent i = new Intent(getApplicationContext(),HistoricoSesiones.class);
        startActivity(i);
    }

    public void Localizar(){
        Intent localizar = new Intent(getApplicationContext(),Localizacion.class);
        startActivity(localizar);
    }



    @Override protected void onStop() {

        super.onStop();

        ContentValues values = new ContentValues();
        values.put("presupuestoActual", presupuestoActual);
        values.put("total_gastado", total_gastado);
        values.put("Id_sesion", Id_sesion);
        values.put("nombreLocal", nombreLocal);
        values.put("descripcion", descripcion);
        values.put("descripcionSalida",descripcionSalida);
        values.put("precio", precio);

        //getContentResolver().update(null, values,null,null);

    }

    public void establecerColorTotalGastado(){

        if(total_gastado > presupuestoActual) {
            //red
            tv_gastado.setTextColor(Color.rgb(231,76,60));
            conseguido = 0;
        }
        else {
            //green
            tv_gastado.setTextColor(Color.rgb(23,165,137));
            conseguido = 1;
        }
    }


}
