package com.example.shikan.eldelbar;

import android.content.Intent;
import android.graphics.Color;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.TextView;

import com.example.shikan.eldelbar.database.EldelbarDB;
import com.example.shikan.eldelbar.database.entidades.Gasto;

import java.util.ArrayList;

public class GastosFinSesion extends AppCompatActivity {

    private TextView tv_titulo;
    private TextView tv_presupuesto;
    private TextView tv_gasto_total;

    //RecyclerView
    private RecyclerView recyclerView;
    private ListaGastosRecyclerViewAdapter adapter;
    private RecyclerView.LayoutManager layoutManager;
    private ArrayList<Gasto> listaGastos;

    private EldelbarDB db;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_gastos_fin_sesion);


        final String id_sesion = getIntent().getStringExtra("id_sesion");
        String descripcion = getIntent().getStringExtra("descripcion");
        final String fecha = getIntent().getStringExtra("fecha");
        final Double presupuesto = getIntent().getDoubleExtra("presupuesto",0.0);
        final Double total_gastado = getIntent().getDoubleExtra("total_gastado",0.0);

        tv_titulo = findViewById(R.id.titulo);
        tv_presupuesto = findViewById(R.id.presupuesto);
        tv_gasto_total = findViewById(R.id.gasto_total);

        descripcion = descripcion+" ("+fecha+")";
        tv_titulo.setText(descripcion);

        tv_presupuesto.setText(Double.valueOf(presupuesto).toString());
        tv_gasto_total.setText(Double.valueOf(total_gastado).toString());

        if(presupuesto == total_gastado || presupuesto > total_gastado) {
            //green
            tv_gasto_total.setTextColor(Color.rgb(23,165,137));
        }
        else {
            //red
            tv_gasto_total.setTextColor(Color.rgb(231,76,60));
        }

        //Recyclerview
        recyclerView = findViewById(R.id.lista_gastos_fin);
        layoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(layoutManager);
        recyclerView.setHasFixedSize(true);
        listaGastos = new ArrayList<>();

        inicializarRecycler(id_sesion);
    }

    public void inicializarRecycler(String id_sesion){

        Log.d("BD","Estamos en inicializarRecycler");
        db = new EldelbarDB(getApplicationContext());

        listaGastos = db.obtenerGastos(id_sesion);
        adapter = new ListaGastosRecyclerViewAdapter(listaGastos, getApplicationContext());
        recyclerView.setAdapter(adapter);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
    }

    /*
    *       MENU
    * */

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.layout.menu, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
            case R.id.menu_NuevoPresupuesto:
                nuevoPresupuesto();
                return true;
            case R.id.menu_Historico:
                Historico();
                return true;
            case R.id.menu_Localizar:
                Localizar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void nuevoPresupuesto(){
        Intent presupuesto = new Intent(getApplicationContext(),NuevoPresupuesto.class);
        startActivity(presupuesto);
    }

    public void Historico(){
        Intent i = new Intent(getApplicationContext(),HistoricoSesiones.class);
        startActivity(i);
    }

    public void Localizar(){
        Intent localizar = new Intent(getApplicationContext(),Localizacion.class);
        startActivity(localizar);
    }
}
