package com.example.shikan.eldelbar;

import com.example.shikan.eldelbar.database.EldelbarDB;

import android.content.Intent; 
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;

import com.example.shikan.eldelbar.database.entidades.Sesion;

import java.util.ArrayList;

public class HistoricoSesiones extends AppCompatActivity {

    //RecyclerView
    private RecyclerView recyclerView;
    private ListaSesionesRecyclerviewAdapter adapter;
    private RecyclerView.LayoutManager layoutManager;
    private ArrayList<Sesion> listaSesiones;
    private String id_sesion;
    private String titulo;
    private double total_gastado;
    private double presupuesto;
    private int conseguido;

    private EldelbarDB db;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_historico_sesiones);

        //Recyclerview
        recyclerView = findViewById(R.id.RV_listaSesiones);
        layoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(layoutManager);
        recyclerView.setHasFixedSize(true);
        listaSesiones = new ArrayList<>();

        db = new EldelbarDB(getApplicationContext());

        inicializarRecycler();
    }

    public void inicializarRecycler(){

        Log.d("BD","Estamos en inicializarRecycler");
        db = new EldelbarDB(getApplicationContext());

        listaSesiones = db.ObtenerTituloSesiones();
        adapter = new ListaSesionesRecyclerviewAdapter(listaSesiones, getApplicationContext());

        // Obtenemos id_sesion
        //id_sesion = listaSesiones.get(recyclerView.get);
        //titulo = listaSesiones.get(0).getTitulo();


        adapter.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                id_sesion = listaSesiones.get(recyclerView.getChildAdapterPosition(v)).getId_sesion();
                titulo = listaSesiones.get(recyclerView.getChildAdapterPosition(v)).getTitulo();
                total_gastado = listaSesiones.get(recyclerView.getChildAdapterPosition(v)).getTotal_gastado();
                conseguido = listaSesiones.get(recyclerView.getChildAdapterPosition(v)).getConseguido();
                presupuesto = listaSesiones.get(recyclerView.getChildAdapterPosition(v)).getPresupuesto();

                Intent i = new Intent(getApplicationContext(), historicoGastos.class);
                i.putExtra("id_sesion",id_sesion);
                i.putExtra("titulo",titulo);
                i.putExtra("total_gastado",total_gastado);
                i.putExtra("conseguido",conseguido);
                i.putExtra("presupuesto", presupuesto);
                startActivity(i);
            }
        });

        recyclerView.setAdapter(adapter);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
    }

    /*
     *       MENU
     * */

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.layout.menu, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
            case R.id.menu_NuevoPresupuesto:
                nuevoPresupuesto();
                return true;
            case R.id.menu_Historico:
                Historico();
                return true;
            case R.id.menu_Localizar:
                Localizar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void nuevoPresupuesto(){
        Intent presupuesto = new Intent(getApplicationContext(),NuevoPresupuesto.class);
        startActivity(presupuesto);
    }

    public void Historico(){
        Intent i = new Intent(getApplicationContext(),HistoricoSesiones.class);
        startActivity(i);
    }

    public void Localizar(){
        Intent localizar = new Intent(getApplicationContext(),Localizacion.class);
        startActivity(localizar);
    }
}
