package com.example.shikan.eldelbar;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Build;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesNotAvailableException;
import com.google.android.gms.common.GooglePlayServicesRepairableException;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.common.api.PendingResult;
import com.google.android.gms.common.api.ResultCallback;
import com.google.android.gms.location.places.GeoDataClient;
import com.google.android.gms.location.places.Place;
import com.google.android.gms.location.places.PlaceDetectionClient;
import com.google.android.gms.location.places.PlaceFilter;
import com.google.android.gms.location.places.PlaceLikelihood;
import com.google.android.gms.location.places.PlaceLikelihoodBuffer;
import com.google.android.gms.location.places.Places;
import com.google.android.gms.location.places.ui.PlacePicker;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapFragment;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.common.api.GoogleApiClient.OnConnectionFailedListener;

import android.support.v4.app.FragmentActivity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;

import java.net.URI;
import java.util.ArrayList;
import java.util.List;

public class Localizacion extends FragmentActivity implements OnConnectionFailedListener {

    private GoogleApiClient googleApiClient;
    private int PLACE_PICKER_REQUEST = 1;

    // The entry points to the Places API.
    private GeoDataClient mGeoDataClient;
    private PlaceDetectionClient mPlaceDetectionClient;

    // A default location (Sydney, Australia) and default zoom to use when location permission is
    // not granted.
    private final LatLng mDefaultLocation = new LatLng(-33.8523341, 151.2106085);
    private static final int DEFAULT_ZOOM = 15;
    private static final int PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION = 1;
    private boolean mLocationPermissionGranted;
    private TextView tv_nombreLocal;
    private TextView tv_direccion;
    private TextView tv_telefono;
    private TextView tv_rating;
    private TextView tv_web;
    private EditText et_titulo;
    private EditText et_presupuesto;
    private ImageButton ib_comoLlegar;
    private String id_sesion;
    private Double total_gastado;
    private Double presupuestoActual;
    private String descripcionSalida;

    private Place lugar;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_localizacion);

        tv_nombreLocal = findViewById(R.id.nombreLocal);
        tv_direccion = findViewById(R.id.direccion);
        tv_telefono = findViewById(R.id.telefono);
        tv_rating = findViewById(R.id.rating);
        tv_web = findViewById(R.id.web);
        ib_comoLlegar = findViewById(R.id.comoLlegar);

        id_sesion = getIntent().getStringExtra("id_sesion");
        total_gastado = getIntent().getDoubleExtra("total_gastado", 0.0);
        presupuestoActual = getIntent().getDoubleExtra("presupuestoActual", 0.0);
        descripcionSalida = getIntent().getStringExtra("descripcionSalida");

        //Construimos un geodataCLient
        mGeoDataClient = Places.getGeoDataClient(this);

        // Construct a PlaceDetectionClient.
        mPlaceDetectionClient = Places.getPlaceDetectionClient(this);

        //Conectamos ala API de Google Places
        googleApiClient = new GoogleApiClient
                .Builder(this)
                .addApi(Places.GEO_DATA_API)
                .addApi(Places.PLACE_DETECTION_API)
                .enableAutoManage(this, this)
                .build();

        googleApiClient.connect();


        //Iniciamos el seleccionador de sitios
        PlacePicker.IntentBuilder builder = new PlacePicker.IntentBuilder();


        try {
            startActivityForResult(builder.build(this), PLACE_PICKER_REQUEST);


        }

        catch (GooglePlayServicesRepairableException e) {
            e.printStackTrace();
        }

        catch (GooglePlayServicesNotAvailableException e) {
            e.printStackTrace();
        }



        if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            // TODO: Consider calling
            //    ActivityCompat#requestPermissions
            // here to request the missing permissions, and then overriding
            //   public void onRequestPermissionsResult(int requestCode, String[] permissions,
            //                                          int[] grantResults)
            // to handle the case where the user grants the permission. See the documentation
            // for ActivityCompat#requestPermissions for more details.
            return;
        }

        @SuppressLint("MissingPermission") PendingResult<PlaceLikelihoodBuffer> result = Places.PlaceDetectionApi
                .getCurrentPlace(googleApiClient, null);
        result.setResultCallback(new ResultCallback<PlaceLikelihoodBuffer>() {
            @Override
            public void onResult(PlaceLikelihoodBuffer likelyPlaces) {
                for (PlaceLikelihood placeLikelihood : likelyPlaces) {
                    String TAG="Sitios";
                    Log.i(TAG, String.format("Place '%s' has likelihood: %g Tipo: '%s'",
                            placeLikelihood.getPlace().getName(),
                            placeLikelihood.getLikelihood(),
                            placeLikelihood.getPlace().getPlaceTypes()));
                }
                likelyPlaces.release();
            }
        });
        
    }

    private void getDeviceLocation() {
        if (ContextCompat.checkSelfPermission(this.getApplicationContext(),
                android.Manifest.permission.ACCESS_FINE_LOCATION)
                == PackageManager.PERMISSION_GRANTED) {
            mLocationPermissionGranted = true;
        } else {
            ActivityCompat.requestPermissions(this,
                    new String[]{android.Manifest.permission.ACCESS_FINE_LOCATION},
                    PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION);
        }
    }


    @Override
    public void onConnectionFailed(@NonNull ConnectionResult connectionResult) {
        //TODO: Falta notificar error de conexión -> HECHO
        String toastMsg = "Error de Conexion";
        Toast.makeText(this, toastMsg, Toast.LENGTH_LONG).show();
    }

    //Una vez seleccionado el sitio, aparecen aqui los detalles
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        if (requestCode == PLACE_PICKER_REQUEST && resultCode == RESULT_OK) {
                Place place = PlacePicker.getPlace(this, data);
                final CharSequence name = place.getName();
                final CharSequence direcc = place.getAddress();
                final CharSequence tfn = place.getPhoneNumber();
                final Float rating = place.getRating();
                final Uri web = place.getWebsiteUri();
                final LatLng ubicacion = place.getLatLng();

                final Uri localizacion = Uri.parse("geo:"+ubicacion.toString()+"?q="+Uri.encode(name.toString()));

                //Codigo del AlertDialog

            AlertDialog.Builder builder = new AlertDialog.Builder(Localizacion.this);

            // Add the buttons
            builder.setTitle("Eldelbar")
                    .setItems(R.array.Opciones, new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            switch (which){
                                case 0:

                                    //Hay una sesion creada
                                    if(id_sesion != null){
                                        //Pasamos el nombre del local a Actual_presupuesto
                                        Intent i = new Intent(getApplicationContext(),ActualPresupuesto.class);
                                        i.putExtra("nombreLocal", name);
                                        i.putExtra("LocalizacionLocal", localizacion.toString());
                                        i.putExtra("direccionLocal",direcc);
                                        i.putExtra("id_sesion",id_sesion);
                                        i.putExtra("presupuestoActual_fromLocalizacion",presupuestoActual);
                                        i.putExtra("total_gastado_fromLocalizacion",total_gastado);
                                        i.putExtra("descripcionSalida_fromLocalizacion",descripcionSalida);
                                        startActivity(i);
                                    }
                                    else{
                                        String localizacionString = localizacion.toString();
                                        dialogo(name.toString() ,direcc.toString() ,localizacionString);
                                        Log.d("Dialogo","Intentando acceder a dialogo()");
                                    }

                                    break;

                                case 1:
                                    if(web == null){
                                        tv_web.setText("No especificado");
                                    }
                                    else {
                                        String url = web.toString();
                                        tv_web.setText(url);
                                    }

                                    String valoracion = Float.valueOf(rating).toString();

                                    tv_nombreLocal.setText(name);
                                    tv_direccion.setText(direcc);
                                    tv_telefono.setText(tfn);
                                    tv_rating.setText(valoracion);

                                    Log.d("LOCALIZACION",ubicacion.toString());


                                    ib_comoLlegar.setOnClickListener(new View.OnClickListener() {
                                        @Override
                                        public void onClick(View v) {
                                            Intent intent = new Intent(Intent.ACTION_VIEW, localizacion);
                                            intent.setPackage("com.google.android.apps.maps");
                                            startActivity(intent);
                                        }
                                    });
                                    break;

                                case 2:

                                            Intent intent = new Intent(Intent.ACTION_VIEW, localizacion);
                                            intent.setPackage("com.google.android.apps.maps");
                                            startActivity(intent);

                                    break;

                                    default:
                                        Toast msg = Toast.makeText(getApplicationContext(),"Error Desconocido.", Toast.LENGTH_SHORT);
                                        msg.show();
                            }
                        }
                    });

            builder.create();
            builder.show();
            //Fin Codigo AlertDialog
        }
    }

    /*
     *       MENU
     * */

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.layout.menu, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
            case R.id.menu_NuevoPresupuesto:
                nuevoPresupuesto();
                return true;
            case R.id.menu_Historico:
                Historico();
                return true;
            case R.id.menu_Localizar:
                Localizar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void nuevoPresupuesto(){
        Intent presupuesto = new Intent(getApplicationContext(),NuevoPresupuesto.class);
        startActivity(presupuesto);
    }

    public void Historico(){
        Intent i = new Intent(getApplicationContext(),HistoricoSesiones.class);
        startActivity(i);
    }

    public void Localizar(){
        Intent localizar = new Intent(getApplicationContext(),Localizacion.class);
        startActivity(localizar);
    }

    public void dialogo (final String nombreLocal, final String direccion, final String localizacion) {

        AlertDialog.Builder builder = new AlertDialog.Builder(Localizacion.this);
        Log.d("Dialogo","Estamos en dialogo()");

        // Get the layout inflater
        //final LayoutInflater inflater = Localizacion.this.getLayoutInflater();

        View inflater = getLayoutInflater().inflate(R.layout.alert_localizacion, null);

        et_titulo = inflater.findViewById(R.id.tituloLocalizacion);
        et_presupuesto = inflater.findViewById(R.id.presupuestoLocalizacion);

        // Inflate and set the layout for the dialog
        // Pass null as the parent view because its going in the dialog layout

        builder.setView(inflater);

                builder.setTitle("Eldelbar")
                // Add action buttons
                .setPositiveButton("Ok", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int id) {

                        Log.d("dialogo","et_titulo: "+et_titulo);

                        Log.d("dialogo","et_presupuesto: "+et_presupuesto);

                        descripcionSalida = et_titulo.getText().toString();
                        Log.d("dialogo","descrtipcionSalida: "+descripcionSalida);
                        presupuestoActual = Double.parseDouble(et_presupuesto.getText().toString());
                        Log.d("dialogo","presupuestoActual: "+presupuestoActual);

                        // Pasamos Titulo, presupuesto, nombreLocal, direccion y localizacion
                        Intent i = new Intent(getApplicationContext(), ActualPresupuesto.class);
                        i.putExtra("presupuesto", presupuestoActual);
                        i.putExtra("descripcionSalida", descripcionSalida);
                        i.putExtra("nombreLocal", nombreLocal);
                        i.putExtra("direccionLocal", direccion);
                        i.putExtra("localizacionLocal", localizacion);
                        startActivity(i);
                    }
                })
                .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        Toast msg = Toast.makeText(getApplicationContext(),"Cancelado", Toast.LENGTH_SHORT);
                        msg.show();
                    }
                });

        builder.create();
        builder.show();
    }
}
