package com.example.shikan.eldelbar;

import android.content.Intent;
import android.graphics.Color;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;

import com.example.shikan.eldelbar.database.EldelbarDB;
import com.example.shikan.eldelbar.database.entidades.Gasto;
import com.example.shikan.eldelbar.database.entidades.Sesion;

import java.util.ArrayList;

public class historicoGastos extends AppCompatActivity {

    private TextView tv_titulo;
    private TextView tv_total_gastado;
    private TextView tv_presupuesto;
    private String id_sesion;
    private String titulo;
    private String fecha;
    private double total_gastado;
    private int conseguido;
    private double presupuesto;

    //RecyclerView
    private RecyclerView recyclerView;
    private ListaGastosRecyclerViewAdapter adapter;
    private RecyclerView.LayoutManager layoutManager;
    private ArrayList<Gasto> listaGastos;

    private EldelbarDB db;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_historico_gastos);

        tv_titulo = findViewById(R.id.TV_titulo_sesion);
        tv_total_gastado = findViewById(R.id.tvGastoHistoricoGastos);
        tv_presupuesto = findViewById(R.id.tvPresupuestoHistoricoGastos);

        //Recyclerview
        recyclerView = findViewById(R.id.RV_listagastos);
        layoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(layoutManager);
        recyclerView.setHasFixedSize(true);
        listaGastos = new ArrayList<>();

        db = new EldelbarDB(getApplicationContext());

        id_sesion = getIntent().getStringExtra("id_sesion");
        titulo = getIntent().getStringExtra("titulo");
        total_gastado = getIntent().getDoubleExtra("total_gastado",0);
        conseguido = getIntent().getIntExtra("conseguido",0);
        presupuesto = getIntent().getDoubleExtra("presupuesto",0);


        fecha = id_sesion.substring(5,15);
        titulo += " ( "+fecha+" )";

        tv_titulo.setText(titulo);
        tv_total_gastado.setText(Double.valueOf(total_gastado).toString());
        tv_presupuesto.setText(Double.valueOf(presupuesto).toString());

        if(conseguido == 1){
            tv_total_gastado.setTextColor(Color.rgb(23,165,137));
        }else
            tv_total_gastado.setTextColor(Color.rgb(231,76,60));

        inicializarRecycler();
    }

    public void inicializarRecycler(){


        Log.d("BD","Estamos en inicializarRecycler");
        db = new EldelbarDB(getApplicationContext());

        listaGastos = db.obtenerGastos(id_sesion);
        adapter = new ListaGastosRecyclerViewAdapter(listaGastos, getApplicationContext());

        recyclerView.setAdapter(adapter);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
    }

    /*
     *       MENU
     * */

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.layout.menu, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
            case R.id.menu_NuevoPresupuesto:
                nuevoPresupuesto();
                return true;
            case R.id.menu_Historico:
                Historico();
                return true;
            case R.id.menu_Localizar:
                Localizar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void nuevoPresupuesto(){
        Intent presupuesto = new Intent(getApplicationContext(),NuevoPresupuesto.class);
        startActivity(presupuesto);
    }

    public void Historico(){
        Intent i = new Intent(getApplicationContext(),HistoricoSesiones.class);
        startActivity(i);
    }

    public void Localizar(){
        Intent localizar = new Intent(getApplicationContext(),Localizacion.class);
        startActivity(localizar);
    }
}
